import { put, call } from "redux-saga/effects";
import * as actions from './../../../actions/auth/signIn'
import axios from 'axios';
import token from './../../../utils/token';

import { SIGN_IN_URL } from './../../../constants/index'

// worker-saga for signing in

export default function* ({ payload: requestBody }) {
    try {
        const payload = yield call(() =>
            axios.post(SIGN_IN_URL, requestBody)
                .then(({ data }) => data)
        );
        
        yield put(actions.signInRequestSucces(payload));
        yield call(localStorage.setItem, token, payload);
    }
    catch ({ message }) {
        yield put(actions.signInRequestFailure(message))
        yield call(localStorage.removeItem, token);
    }
}